// Программа фигуры Лиссажу
// СУНЦ НГУ 2002-2004-2020
// Program liss
////////////////////////////////////////////////////////////
#include <cmath>

#include <mpp/mpp_window.h>
#include <mpp/draw.h>

using namespace mpp;

double dt=0.01;
double rtime=0;

double a1=1.0;
double a2=1.0;
double omega1=1.0;
double omega2=1.2;

Scale scale(-1.5, 1.5, -1.5, 1.5, KEEP_RATIO);     // Масштаб
Orbit orbit(1000, 100, FL_RED, FL_WHITE, scale);   // Отрисовка траектории

void ff(){
   double x, y;
   //  Основной цикл
   while (may_i_repeat()){         // пока не попросят редактирования
      rtime+=dt;
      x=a1*cos(omega1*rtime);
      y=a2*cos(omega2*rtime);
      orbit.add(x, y);            // добавить точку к траектории
      ask_update();               // перерисовать окошко
      msleep(0.0001);
   }
};

int main(void){
   Mpp_window win;    // Отображаемое окно
   //  Построение таблицы-пульта
   win.table.add_item("dt = ", dt);
   win.table.add_item("omega1 = ", omega1);
   win.table.add_item("omega2 = ", omega2);
   win.table.add_item("a1 = ", a1);
   win.table.add_item("a2 = ", a2);       

   //  Что будем рисовать
   win.canvas.add_shape(&orbit);

   set_work(ff);  //  Подключаем расчетную функцию
   start();
   run();
   return 0;
}

