// Программа колебания маятника
// СУНЦ НГУ 2002-2004-2020
// Program beats
////////////////////////////////////////////////////////////
#include <cmath>

#include <mpp/mpp_window.h>
#include <mpp/draw.h>

using namespace mpp;

Scale scale(-M_PI, M_PI, -3, 3);           // Масштаб
Orbit orbit(10000, 100, FL_WHITE, FL_GREEN, scale);    // Отрисовка фазового портрета

double dt=0.005;
double t=0.0;                // текущее время
double alpha=0.0;
double v=1.5;

void ff(){
   //  Основной цикл
   while (may_i_repeat()){             // пока не попросят редактирования
      t+=dt;
      alpha+=v*dt;
      if (alpha>M_PI) alpha-=2.0*M_PI;
      else if (alpha<(-M_PI)) alpha+=2.0*M_PI;
      v-=sin(alpha)*dt;      
      orbit.add(alpha, v);        // добавить точку к траектории
      ask_update();               // перерисовать окошко
      msleep(0.001);
   }
   t=0.0;  alpha=0.0;  v=1.5;
};

int main(void){
	Mpp_window win;
    // Построение таблицы-пульта
    win.table.add_item("Time = ", t);
    win.table.add_item("alpha = ", alpha);
    win.table.add_item("v = ", v);
    win.table.add_item("dt = ", dt);

    // Что будем рисовать
    win.canvas.add_shape(&orbit);

    set_work(ff);  //  Подключаем расчетную функцию
    start();
	return run();
}
